(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', './index'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('./index'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.index);
    global.decorator = mod.exports;
  }
})(this, function (exports, _react, _index) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });

  var _react2 = _interopRequireDefault(_react);

  var _index2 = _interopRequireDefault(_index);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _objectWithoutProperties(obj, keys) {
    var target = {};

    for (var i in obj) {
      if (keys.indexOf(i) >= 0) continue;
      if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
      target[i] = obj[i];
    }

    return target;
  }

  var cloneChildren = function cloneChildren(children, props) {
    return _react2.default.Children.map(children, function (child) {
      return typeof child.type === 'function' ? _react2.default.cloneElement(child, props) : null;
    });
  };

  var createChildren = function createChildren(components, props) {
    var index = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;

    if (components[index]) {
      return _react2.default.createElement(components[index], props, createChildren(components, props, index + 1));
    } else {
      var children = props.children,
          rest = _objectWithoutProperties(props, ['children']);

      return children ? cloneChildren(children, rest) : null;
    }
  };

  exports.default = function (apiProps) {
    return function ApiDecorator(children, maybeComponent, maybeContext) {
      return maybeContext ? _react2.default.createElement(_index2.default, apiProps, createChildren(children, maybeComponent)) : ApiDecorator.bind(null, [].concat(children, maybeComponent || []));
    };
  };
});