(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', './api', './api/decorator', './store', './container', './subscribe', './tree_viewer'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('./api'), require('./api/decorator'), require('./store'), require('./container'), require('./subscribe'), require('./tree_viewer'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.api, global.decorator, global.store, global.container, global.subscribe, global.tree_viewer);
    global.index = mod.exports;
  }
})(this, function (exports, _api, _decorator, _store, _container, _subscribe, _tree_viewer) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  Object.defineProperty(exports, 'Api', {
    enumerable: true,
    get: function () {
      return _interopRequireDefault(_api).default;
    }
  });
  Object.defineProperty(exports, 'apiDecorator', {
    enumerable: true,
    get: function () {
      return _interopRequireDefault(_decorator).default;
    }
  });
  Object.defineProperty(exports, 'store', {
    enumerable: true,
    get: function () {
      return _interopRequireDefault(_store).default;
    }
  });
  Object.defineProperty(exports, 'container', {
    enumerable: true,
    get: function () {
      return _interopRequireDefault(_container).default;
    }
  });
  Object.defineProperty(exports, 'localState', {
    enumerable: true,
    get: function () {
      return _subscribe.localState;
    }
  });
  Object.defineProperty(exports, 'globalState', {
    enumerable: true,
    get: function () {
      return _subscribe.globalState;
    }
  });
  Object.defineProperty(exports, 'TreeViewer', {
    enumerable: true,
    get: function () {
      return _interopRequireDefault(_tree_viewer).default;
    }
  });

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }
});