(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define(['exports', 'react', '../api'], factory);
  } else if (typeof exports !== "undefined") {
    factory(exports, require('react'), require('../api'));
  } else {
    var mod = {
      exports: {}
    };
    factory(mod.exports, global.react, global.api);
    global.decorator = mod.exports;
  }
})(this, function (exports, _react, _api) {
  'use strict';

  Object.defineProperty(exports, "__esModule", {
    value: true
  });
  exports.default = apiDecorator;

  var _react2 = _interopRequireDefault(_react);

  var _api2 = _interopRequireDefault(_api);

  function _interopRequireDefault(obj) {
    return obj && obj.__esModule ? obj : {
      default: obj
    };
  }

  function _objectWithoutProperties(obj, keys) {
    var target = {};

    for (var i in obj) {
      if (keys.indexOf(i) >= 0) continue;
      if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
      target[i] = obj[i];
    }

    return target;
  }

  var createChildren = function createChildren(components, props) {
    var index = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;

    if (components[index]) {
      return _react2.default.createElement(components[index], props, createChildren(components, props, index + 1));
    } else {
      var children = props.children,
          rest = _objectWithoutProperties(props, ['children']);

      return children ? _react2.default.cloneElement(children, rest) : null;
    }
  };

  function apiDecorator(apiProps) {

    function MyApi(props, children) {
      return _react2.default.createElement(_api2.default, apiProps, createChildren(children, props));
    }

    return function ApiDecorator(memo, maybeComponent, maybeContext) {
      return maybeContext ? MyApi(maybeComponent, memo) : ApiDecorator.bind(null, maybeComponent ? memo.concat(maybeComponent) : [memo]);
    };
  }
});